#!/usr/lbin/perl
# revoke_init.pl
# This program generates the initial random DES key and sequence number.
# It uses Dennis Ferguson's PERL DES library.  Read his license before
# doing anything legally important. -Kevin Fu 8-16-96

require 'des-lib.perl';
require 'revokelib.pl';

print<<"EndOfInfo";
Welcome to the Internet Revocation Program, or
How to Change Your Mind on the Internet.

Please type in a random string to generate your initial random key.  Hit
a carriage return to terminate your random string.

EndOfInfo

print "String: ";
chop($string=<STDIN>);

# This is VERY predictable and insecure.  But it looks pretty and adds
# some variance to the seed as many people may use the same initial string.
srand (time||$$);
$salt=rand(2**16);
$string.="$salt";

# Fold the string into an packed 8-byte random key (MIT's string2key)
$key=&string2key($string);

# Get a HEX string representation
$unp_hkey=unpack("H*",$key);

$sequence=0;
print "\nHex Random Seed     : $unp_hkey\n";
print "Sequence Number     : $sequence\n\n";

# Store sequence number and then the hex string of the random seed.
# Overwriting the mhrevoke shouldn't be a problem as it's just
# the random seed.

chop($folder=`mhparam mhrevokefolder`); # revoke
if ($folder=~/^$/) { $folder="revoke"; }
chop($path=`mhparam path`); # Mail
if ($path=~/^$/) { $path="Mail"; }

`mkdir $ENV{'HOME'}/$path/$folder` unless (-e "$ENV{'HOME'}/$path/$folder");
# The above -e conditional doesn't seem to do anything.

&revokelib'store_params($sequence,$unp_hkey);

print "Finished generating inital seed and sequence.  Have a secure day!\n";
print "This message was brought to you by the letter 'Q' and the random\n";
print "number $salt.\n";


